<?php
/* utf8-marker = äöüß */

/*
 * xlang_XH
 *
 * @author Olaf Penschke (olape)
 * @version 1.4.1 (09.02.2018)
 * @Anpassung für CMSimple XH in beta4 von cmb

 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

================================================================================

hreflang-Attribut für Sprach- oder Regions-URL Ihrer Seiten verwenden
https://support.google.com/webmasters/answer/189077?hl=de

mithilfe kanonischer URLs die Link- und Rankingsignale von Inhalten verbessern
https://support.google.com/webmasters/answer/139066?hl=de

================================================================================
*/

if( 'xlang.php' == basename($_SERVER['SCRIPT_FILENAME']) )
{
	die('No direct access.');
}

//******************************************************************************
// Basis-URL
if(!empty($plugin_cf['xlang']['xlang_basis_url']))
{
	$op_basis_url = $plugin_cf['xlang']['xlang_basis_url'];
}

//******************************************************************************

function op_canonical($op_get_x = '')
{
	global $cf, $sl, $s, $su, $plugin_cf, $xh_publisher, $op_basis_url;

	$op_can_query_string = preg_replace('#%(25)*' . bin2hex($cf['uri']['seperator']) . '#i', $cf['uri']['seperator'], $_SERVER['QUERY_STRING']);				//  / --> Seitentrenner (z.B. / --> %2F, : --> %3A) manchmal doppelt encodiert --> %252F, Facebook, u.ä.
	$op_can_request_url = $_SERVER['REQUEST_URI'];
	$t = '';
	$op_can_count = 0;
	$op_can_url_tmp = '';

	if((isset($op_basis_url)) && ($plugin_cf['xlang']['canonical_set'] != 'none'))
	{

		if($sl == $cf['language']['default'])																													// Basis-URL Defaultsprache
		{
			$op_basis_url_can = $op_basis_url;
		}
		else
		{
			$op_basis_url_can = $op_basis_url . '/' . $sl;																										// Basis-URL Zweitsprachen
		}

		if(($s == $xh_publisher->getFirstPublishedPage()) && ($su != ''))
		{
			$op_can_query_string = str_replace($su, '', $op_can_query_string);
			$op_can_count++;
		}

		if(substr_count($op_can_request_url, 'index.php') > 0)
		{
			$op_can_query_string = str_replace('index.php', '', $op_can_query_string);
			$op_can_count++;
		}

		if($op_get_x != '')
		{
			$op_get_x_tmp_array = explode('|', $op_get_x);																										// Parameter aus $plugin_cf['xlang']['canonical_get_x'] entfernen
			foreach($op_get_x_tmp_array as $op_get_x_tmp)
			{
				if($op_get_x_tmp == 'selected')
				{
					$op_can_query_string = str_replace('selected=', '', $op_can_query_string);
				}
				else if($op_get_x_tmp == 'login')
				{
					$op_can_query_string = '';
				}
				else
				{
					$op_can_query_string = preg_replace('#&?' . $op_get_x_tmp . '[^&]*#is', '', $op_can_query_string);
				}
			}
			$op_can_url_tmp = $op_basis_url_can . (($op_can_query_string != '') ? ('/?' . $op_can_query_string) : ('/'));
			$t .= '<link rel="canonical" href="' . $op_can_url_tmp . '">' . "\n";
			return $t;
		}

		if(($op_can_count > 0) || ($plugin_cf['xlang']['canonical_set'] == 'max'))
		{
			$op_can_url_tmp = $op_basis_url_can . (($op_can_query_string != '') ? ('/?' . $op_can_query_string) : ('/'));
			$t .= '<link rel="canonical" href="' . $op_can_url_tmp . '">' . "\n";
			return $t;
		}

	}
}

//******************************************************************************

function op_xlang()
{
	global $cf, $sl, $s, $su, $plugin_cf, $xh_publisher, $op_basis_url;

	$op_xlang_request_url = $_SERVER['REQUEST_URI'];
	$op_xlang_query_string = preg_replace('#%(25)*' . bin2hex($cf['uri']['seperator']) . '#i', urlencode($cf['uri']['seperator']), $_SERVER['QUERY_STRING']);	//  / --> Seitentrenner (z.B. / --> %2F, : --> %3A) manchmal doppelt encodiert --> %252F, Facebook, u.ä.
	$t = '';
	$op_xlang_url_tmp = '';

	if((isset($op_basis_url)) 
	&& (substr_count($op_xlang_request_url, 'index.php') == 0)
	&& (substr_count($op_xlang_query_string, urlencode($cf['uri']['seperator'])) == 0)) 																		//   / --> %2F, : --> %3A Facebook, u.ä.
	{

		if((($s == $xh_publisher->getFirstPublishedPage()) 
		&& ($op_xlang_request_url == '/')) 
		|| ($s != $xh_publisher->getFirstPublishedPage()))
		{
			// Zweitsprachen Array erzeugen
			$r = XH_secondLanguages();
			// default und x-default in Defaultsprache
			if($sl == $cf['language']['default'])
			{
				$op_xlang_url_tmp = $op_basis_url . (($op_xlang_query_string != '') ? ('/?' . $op_xlang_query_string) : ('/'));
				$t .= '<link rel="alternate" hreflang="x-default" href="' 
				   . $op_xlang_url_tmp 
				   . '">' 
				   . "\n";
				if((!empty($plugin_cf['xlang']['xdefault_both'])) 
				&& ($plugin_cf['xlang']['xdefault_both'] == 'true'))
				{
					$t .= '<link rel="alternate" hreflang="' 
					   . $cf['language']['default'] 
					   . '" href="' 
					   . $op_xlang_url_tmp 
					   . '">' 
					   . "\n";
				}
			}
			// default und x-default in Zweitsprachen
			if($sl != $cf['language']['default'])
			{
				if(((substr_count($op_xlang_query_string, 'sitemap') > 0) 
				 || (substr_count($op_xlang_query_string, 'mailform')) > 0) 
				 && ($su == ''))
				{
					$t .= '<link rel="alternate" hreflang="x-default" href="' 
					   . $op_basis_url 
					   . '/?' 
					   . $op_xlang_query_string 
					   . '">' 
					   . "\n";
					if((!empty($plugin_cf['xlang']['xdefault_both'])) 
					&& ($plugin_cf['xlang']['xdefault_both'] == 'true'))
					{
						$t .= '<link rel="alternate" hreflang="' 
						   . $cf['language']['default'] 
						   . '" href="' 
						   . $op_basis_url 
						   . '/?' 
						   . $op_xlang_query_string 
						   . '">' 
						   . "\n";
					}
				}
				else
				{
					$op_xlang_url_tmp = $op_basis_url;
					$t .= '<link rel="alternate" hreflang="x-default" href="' 
					   . $op_xlang_url_tmp 
					   . '/">' 
					   . "\n";
					if((!empty($plugin_cf['xlang']['xdefault_both'])) 
					&& ($plugin_cf['xlang']['xdefault_both'] == 'true'))
					{
						$t .= '<link rel="alternate" hreflang="' 
						   . $cf['language']['default'] 
						   . '" href="' 
						   . $op_xlang_url_tmp 
						   . '/">' 
						   . "\n";
					}
				}
			}
			// Zweitsprachen
			$v = count($r);
			for ($i = 0;$i < $v;$i++)
			{
				$op_sec_lang = str_replace('|', '', $r[$i]);
				if($sl == $op_sec_lang)
				{
					$op_xlang_url_tmp = $op_basis_url 
									  . '/' 
									  . $sl 
									  . (($op_xlang_query_string != '') 
									  ? ('/?' . $op_xlang_query_string) 
									  : ('/'));
					$t .= '<link rel="alternate" hreflang="' 
					   . $sl 
					   . '" href="' 
					   . $op_xlang_url_tmp  
					   . '">' 
					   . "\n";
				}
				else
				{
					if(((substr_count($op_xlang_query_string, 'sitemap') > 0) 
					||  (substr_count($op_xlang_query_string, 'mailform') > 0)) 
					&& ($su == ''))
					{
						$t .= '<link rel="alternate" hreflang="' 
						   . $op_sec_lang 
						   . '" href="' 
						   . $op_basis_url 
						   . '/' 
						   . $op_sec_lang 
						   . '/?' 
						   . $op_xlang_query_string 
						   . '">' 
						   . "\n";
					}
					else
					{
						$t .= '<link rel="alternate" hreflang="' 
						   . $op_sec_lang 
						   . '" href="' 
						   . $op_basis_url 
						   . '/' 
						   . $op_sec_lang 
						   . '/">' 
						   . "\n";
					}
				}
			}
		}
	}

	return $t;

}

?>